/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: trap.c /main/4 1996/08/16 15:31:57 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Advanced Software Technology Department            *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                    {research,attmail}!dgk                    *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
#include	"defs.h"
#include	<ctype.h>
#include	"jobs.h"
#include	"builtins.h"

#define L_FLAG	1
#define S_FLAG	2

static const char trapfmt[] = "trap -- %s %s\n";

static int	sig_number __PROTO__((const char*));
static void	sig_list __PROTO__((int));

int	b_trap __PARAM__((int argc,char *argv[],__V_ *extra), (argc, argv, extra)) __OTORP__(int argc;char *argv[];__V_ *extra;){
	char *arg = argv[1];
	int sig, pflag = 0;
	NOT_USED(argc);
	NOT_USED(extra);
	while (sig = optget(argv, sh_opttrap)) switch (sig)
	{
	    case 'p':
		pflag=1;
		break;
	    case ':':
		error(2, opt_arg);
		break;
	    case '?':
		error(ERROR_usage(2), opt_arg);
		break;
	}
	argv += opt_index;
	if(error_info.errors)
		error(ERROR_usage(2),optusage((char*)0));
	if(arg = *argv)
	{
		int	clear;
		char *action = arg;
		if(!pflag)
		{
			/* first argument all digits or - means clear */
			while(isdigit(*arg))
				arg++;
			clear = (arg!=action && *arg==0);
			if(!clear)
			{
				++argv;
				if(*action=='-' && action[1]==0)
					clear++;
			}
			while(!argv[0])
				error(ERROR_exit(1),e_condition);
		}
		while(arg = *argv++)
		{
			sig = sig_number(arg);
			if(sig<0)
			{
				error(2,e_trap,arg);
				return(1);
			}
			/* internal traps */
			if(sig&SH_TRAP)
			{
				sig &= ~SH_TRAP;
				if(sig>SH_DEBUGTRAP)
				{
					error(2,e_trap,arg);
					return(1);
				}
				if(pflag)
				{
					if(arg=sh.st.trap[sig])
						sfputr(sfstdout,sh_fmtq(arg),'\n');
					continue;
				}
				if(sh.st.trap[sig])
					free(sh.st.trap[sig]);
				sh.st.trap[sig] = 0;
				if(!clear && *action)
					sh.st.trap[sig] = strdup(action);
				if(sig == SH_DEBUGTRAP)
				{
					if(sh.st.trap[sig])
						sh.trapnote |= SH_SIGTRAP;
					else
						sh.trapnote = 0;
				}
				continue;
			}
			if(sig>sh.sigmax)
			{
				error(2,e_trap,arg);
				return(1);
			}
			else if(pflag)
			{
				if(arg=sh.st.trapcom[sig])
					sfputr(sfstdout,sh_fmtq(arg),'\n');
			}
			else if(clear)
				sh_sigclear(sig);
			else
			{
				if(sig >= sh.st.trapmax)
					sh.st.trapmax = sig+1;
				if(arg=sh.st.trapcom[sig])
					free(arg);
				sh.st.trapcom[sig] = strdup(action);
				sh_sigtrap(sig);
			}
		}
	}
	else /* print out current traps */
		sig_list(-1);
	return(0);
}

int	b_kill __PARAM__((int argc,char *argv[],__V_ *extra), (argc, argv, extra)) __OTORP__(int argc;char *argv[];__V_ *extra;){
	char *signame;
	int sig=SIGTERM, flag=0, n;
	NOT_USED(argc);
	NOT_USED(extra);
	while((n = optget(argv,sh_optkill))) switch(n)
	{
		case ':':
			if((signame=argv[opt_index++]) && (sig=sig_number(signame+1))>=0)
			{
				if(argv[opt_index] && strcmp(argv[opt_index],"--")==0)
					opt_index++;
				goto endopts;
			}
			opt_index--;
			error(2, opt_arg);
			break;
		case 'n':
			sig = (int)opt_num;
			break;
		case 's':
			flag |= S_FLAG;
			signame = opt_arg;
			break;
		case 'l':
			flag |= L_FLAG;
			break;
		case '?':
			error(ERROR_usage(2), opt_arg);
			break;
	}
endopts:
	argv += opt_index;
	if(error_info.errors || flag==(L_FLAG|S_FLAG) || (!(*argv) && !(flag&L_FLAG)))
		error(ERROR_usage(2),optusage((char*)0));
	/* just in case we send a kill -9 $$ */
	sfsync(sfstderr);
	if(flag&L_FLAG)
	{
		if(!(*argv))
			sig_list(0);
		else while(signame = *argv++)
		{
			if(isdigit(*signame))
				sig_list((atoi(signame)&0177)+1);
			else
			{
				if((sig=sig_number(signame))<0)
				{
					sh.exitval = 2;
					error(ERROR_exit(1),e_nosignal,signame);
				}
				sfprintf(sfstdout,"%d\n",sig);
			}
		}
		return(sh.exitval);
	}
	if(flag&S_FLAG)
	{
		if((sig=sig_number(signame)) < 0 || sig > sh.sigmax)
			error(ERROR_exit(1),e_nosignal,signame);
	}
	if(job_walk(sfstdout,job_kill,sig,argv))
		sh.exitval = 1;
	return(sh.exitval);
}

/*
 * Given the name or number of a signal return the signal number
 */

static int sig_number __PARAM__((const char *string), (string)) __OTORP__(const char *string;){
	int n;
	char *last;
	if(isdigit(*string))
	{
		n = strtol(string,&last,10);
		if(*last)
			n = -1;
	}
	else
	{
		int c;
		n = staktell();
		do
		{
			c = *string++;
			if(islower(c))
				c = toupper(c);
			stakputc(c);
		}
		while(c);
		stakseek(n);
		init_shtab_signals();
		n = sh_lookup(stakptr(n),shtab_signals);
		n &= (1<<SH_SIGBITS)-1;
		if(n < SH_TRAP)
			n--;
	}
	return(n);
}

/*
 * if <flag> is positive, then print signal name corresponding to <flag>
 * if <flag> is zero, then print all signal names
 * if <flag> is negative, then print all traps
 */
static void sig_list __PARAM__((int flag), (flag)) __OTORP__(int flag;){
	const struct shtable2	*tp;
	int sig = sh.sigmax+1;
	const char *names[SH_TRAP];
	const char *traps[SH_DEBUGTRAP+1];

	init_shtab_signals();

	tp=shtab_signals;
	if(flag==0)
	{
		/* not all signals may be defined, so initialize */
		while(--sig >= 0)
			names[sig] = 0;
		for(sig=SH_DEBUGTRAP; sig>=0; sig--)
			traps[sig] = 0;
	}
	while(*tp->sh_name)
	{
		sig = tp->sh_number;
		sig &= ((1<<SH_SIGBITS)-1);
		if(sig==flag)
		{
			sfprintf(sfstdout,"%s\n",tp->sh_name);
			return;
		}
		else if(sig&SH_TRAP)
			traps[sig&~SH_TRAP] = (char*)tp->sh_name;
		else if(sig < sizeof(names)/sizeof(char*))
			names[sig] = (char*)tp->sh_name;
		tp++;
	}
	if(flag > 0)
		sfprintf(sfstdout,"%d\n",flag-1);
	else if(flag<0)
	{
		/* print the traps */
		char *trap,*sname,**trapcom;
		sig = sh.st.trapmax;
		/* use parent traps if otrapcom is set (for $(trap)  */
		trapcom = (sh.st.otrapcom?sh.st.otrapcom:sh.st.trapcom);
		while(--sig >= 0)
		{
			if(!(trap=trapcom[sig]))
				continue;
			if(!(sname=(char*)names[sig+1]))
			{
				sname="SIG??";
				sname[3] = (sig/10)+'0';
				sname[4] = (sig%10)+'0';
			}
			sfprintf(sfstdout,trapfmt,sh_fmtq(trap),sname);
		}
		for(sig=SH_DEBUGTRAP; sig>=0; sig--)
		{
			if(!(trap=sh.st.trap[sig]))
				continue;
			sfprintf(sfstdout,trapfmt,sh_fmtq(trap),traps[sig]);
		}
	}
	else
	{
		/* print all the signal names */
		for(sig=2; sig <= sh.sigmax; sig++)
		{
			if(names[sig])
				sfputr(sfstdout,names[sig],'\n');
			else
				sfprintf(sfstdout,"SIG%d\n",sig-1);
		}
	}
}

