/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: ulimit.c /main/3 1995/11/01 16:30:47 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Advanced Software Technology Department            *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                    {research,attmail}!dgk                    *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
#include	<ast.h>
#include	<sfio.h>
#include	<error.h>
#include	<shell.h>
#include	"builtins.h"
#include	"ulimit.h"

#ifdef _no_ulimit
	int	b_ulimit __PARAM__((int argc,char *argv[],__V_ *extra), (argc, argv, extra)) __OTORP__(int argc;char *argv[];__V_ *extra;){
		NOT_USED(argc);
		NOT_USED(argv);
		NOT_USED(extra);
		error(ERROR_exit(2),e_nosupport);
		return(0);
	}
#else

#define HARD	1
#define SOFT	2

int	b_ulimit __PARAM__((int argc,char *argv[],__V_ *extra), (argc, argv, extra)) __OTORP__(int argc;char *argv[];__V_ *extra;){
	char *limit;
	int flag = 0, mode=0, n;
#ifdef _lib_getrlimit
	struct rlimit rlp;
#endif /* _lib_getrlimit */
	const Shtable_t *tp;
	int label, unit, noargs;
	long i;
	NOT_USED(extra);
	while((n = optget(argv,sh_optulimit))) switch(n)
	{
		case 'H':
			mode |= HARD;
			continue;
		case 'S':
			mode |= SOFT;
			continue;
		case 'f':
			flag |= (1<<1);
			break;
		case 'a':
#ifdef _lib_ulimit
			flag = (1<<1);
			break;
#else
			flag = (0x2f
#   ifdef RLIMIT_RSS
			|(1<<4)
#   endif /* RLIMIT_RSS */
#   ifdef RLIMIT_NOFILE
			|(1<<6)
#   endif /* RLIMIT_NOFILE */
#   ifdef RLIMIT_VMEM
			|(1<<7)
#   endif /* RLIMIT_VMEM */
				);
			break;
		case 't':
			flag |= 1;
			break;
#   ifdef RLIMIT_RSS
		case 'm':
			flag |= (1<<4);
			break;
#   endif /* RLIMIT_RSS */
		case 'd':
			flag |= (1<<2);
			break;
		case 's':
			flag |= (1<<3);
			break;
		case 'c':
			flag |= (1<<5);
			break;
#   ifdef RLIMIT_NOFILE
		case 'n':
			flag |= (1<<6);
			break;
#   endif /* RLIMIT_NOFILE */
#   ifdef RLIMIT_VMEM
		case 'v':
			flag |= (1<<7);
			break;
#   endif /* RLIMIT_VMEM */
#endif /* _lib_ulimit */
		case ':':
			error(2, opt_arg);
			break;
		case '?':
			error(ERROR_usage(2), opt_arg);
			break;
	}
	limit = argv[opt_index];
	/* default to -f */
	if(noargs=(flag==0))
		flag |= (1<<1);
	/* only one option at a time for setting */
	label = (flag&(flag-1));
	if(error_info.errors || (limit && label) || argc>opt_index+1)
		error(ERROR_usage(2),optusage((char*)0));
	tp = shtab_limits;
	if(mode==0)
		mode = (HARD|SOFT);
	for(; flag; tp++,flag>>=1)
	{
		if(!(flag&1))
			continue;
		n = tp->sh_number>>11;
		unit = tp->sh_number&0x7ff;
		if(limit)
		{
			if(sh.subshell)
				sh_subfork();
			if(strcmp(limit,e_unlimited)==0)
				i = INFINITY;
			else
			{
				char *last;
				if((i=sh_strnum(limit,&last)) < 0 || *last)
					error(ERROR_system(1),e_number,limit);
				i *= unit;
			}
#ifdef _lib_getrlimit
			if(getrlimit(n,&rlp) <0)
				error(ERROR_system(1),e_number,limit);
			if(mode&HARD)
				rlp.rlim_max = i;
			if(mode&SOFT)
				rlp.rlim_cur = i;
			if(setrlimit(n,&rlp) <0)
				error(ERROR_system(1),e_overlimit,limit);
#else
			if((i=vlimit(n,i)) < 0)
				error(ERROR_system(1),e_number,limit);
#endif /* _lib_getrlimit */
		}
		else
		{
#ifdef  _lib_getrlimit
			if(getrlimit(n,&rlp) <0)
				error(ERROR_system(1),e_number,limit);
			if(mode&HARD)
				i = rlp.rlim_max;
			if(mode&SOFT)
				i = rlp.rlim_cur;
#else
#   ifdef _lib_ulimit
			n--;
#   endif /* _lib_ulimit */
			i = -1;
			if((i=vlimit(n,i)) < 0)
				error(ERROR_system(1),e_number,limit);
#endif /* _lib_getrlimit */
			if(label)
				sfputr(sfstdout,tp->sh_name,' ');
			if(i!=INFINITY || noargs)
			{
				if(!noargs)
					i += (unit-1);
				sfprintf(sfstdout,"%d\n",i/unit);
			}
			else
				sfputr(sfstdout,e_unlimited,'\n');
		}
	}
	return(0);
}
#endif /* _no_ulimit */
