/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: nval.h /main/3 1995/11/01 16:41:55 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Advanced Software Technology Department            *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                    {research,attmail}!dgk                    *
*                                                              *
***************************************************************/

/* : : generated by proto : : */
                  
#ifndef NV_DEFAULT
#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif

/*
 * David Korn
 * AT&T Bell Laboratories
 *
 * Interface definitions of structures for name-value pairs
 * These structures are used for named variables, functions and aliases
 *
 */


#include	<ast.h>
#include	<hash.h>

typedef struct Namval Namval_t;
typedef struct Namfun Namfun_t;
typedef struct Namdisc Namdisc_t;
typedef struct Namarray Namarr_t;
/*
 * This defines the template for nodes that have their own assignment
 * and or lookup functions
 */
struct Namdisc
{
	size_t	dsize;
	void	(*putval) __PROTO__((Namval_t*, const char*, int, Namfun_t*));
	char	*(*getval) __PROTO__((Namval_t*, Namfun_t*));
	double	(*getnum) __PROTO__((Namval_t*, Namfun_t*));
	char	*(*setdisc) __PROTO__((Namval_t*, const char*, Namval_t*, Namfun_t*));
	Namval_t *(*create) __PROTO__((Namval_t*, const char*, Namfun_t*));
	char	*(*name) __PROTO__((Namval_t*, Namfun_t*));
	int	(*scope) __PROTO__((Namval_t*, Namval_t*, int, Namfun_t*));
};

struct Namfun
{
	const Namdisc_t *disc;
	Namfun_t *next;
};

/* This is an array template header */
struct Namarray
{
	long	nelem;					/* number of elements */
	__V_	*(*fun) __PROTO__((Namval_t*,const char*,int));	/* associative arrays */
};

/* attributes of name-value node attribute flags */

#define NV_DEFAULT 0
/* This defines the attributes for an attributed name-value pair node */
struct Namval
{
	HASH_HEADER;			/* space for hash library */
	unsigned short	nvflag; 	/* attributes */
	short 		nvsize;		/* size of item */
#ifdef _NV_PRIVATE
	_NV_PRIVATE
#else	/* hopefully these will become private soon */
	char		*nvalue;
	char		*nvenv;         /* pointer to environment name */
	Namfun_t	*nvfun;         /* pointer to trap disciplines */
#endif /* _NV_PRIVATE */
	char            *nvdtenv;       /* dtksh-specific environment name */
};

/* The following attributes are for internal use */
#define NV_NOALLOC	0x100	/* don't allocate space for the value */
#define NV_NOFREE	0x200	/* don't free the space when releasing value */
#define NV_ARRAY	0x400	/* node is an array */

#define NV_INTEGER	0x2	/* integer attribute */
/* The following attributes are valid only when NV_INTEGER is off */
#define NV_LTOU		0x4	/* convert to uppercase */
#define NV_UTOL		0x8	/* convert to lowercase */
#define NV_ZFILL	0x10	/* right justify and fill with leading zeros */
#define NV_RJUST	0x20	/* right justify and blank fill */
#define NV_LJUST	0x40	/* left justify and blank fill */

/* The following attributes do not effect the value */
#define NV_RDONLY	0x1	/* readonly bit */
#define NV_EXPORT	0x2000	/* export bit */
#define NV_REF		0x4000	/* reference bit */
#define NV_TAGGED	0x8000	/* user define tag bit */

/* The following are used with NV_INTEGER */
#define NV_SHORT	(NV_LTOU)	/* when integers are not long */
#define NV_UNSIGN	(NV_UTOL)	/* for unsigned quantities */
#define NV_DOUBLE	(NV_ZFILL)	/* for floating point */
#define NV_EXPNOTE	(NV_LTOU)	/* for scientific notation */
#define NV_CPOINTER	(NV_RJUST)	/* for pointer */


/*  options for nv_open */

#ifdef _NV_PRIVATE
#   define NV_ADD		(HASH_CREATE|HASH_SIZE((long)sizeof(Namval_t)))
#else
#   define NV_ADD		(HASH_CREATE|HASH_SIZE((long)sizeof(Namval_t))+2*sizeof(char*))
#endif /* _NV_PRIVATE */
						/* add node if not found */
#define NV_NOSCOPE	NV_NOALLOC		/* look only in current scope */
#define NV_ASSIGN	NV_NOFREE		/* assignment is possible */
#define NV_NOASSIGN	0			/* backward compatibility */
#define NV_NOARRAY	NV_ARRAY		/* array name not possible */
#define NV_NOREF	NV_REF			/* don't follow reference */
#define NV_IDENT	0x80			/* name must be identifier */
#define NV_VARNAME	0x800			/* name must be ?(.)id*(.id) */
#define NV_NOADD	0x1000			/* do not add node */ 	

#define NV_PUBLIC	(~(NV_NOSCOPE|NV_ASSIGN|NV_IDENT|NV_VARNAME|NV_NOADD))

/* name-value pair macros */
#define nv_isattr(np,f)		((np)->nvflag & (f))
#ifdef _NV_PRIVATE
#   define nv_isnull(np)	(!(np)->nvalue.cp && !(np)->nvfun)  /* strings only */
#else
#   define nv_isnull(np)	(!(np)->nvalue && !(np)->nvfun)  /* strings only */
#endif /* _NV_PRIVATE */
#define nv_name(np)		hashname((Hashbin_t*)(np))
#define nv_size(np)		((np)->nvsize&0xfff)
#define nv_unscope()		(sh.var_tree = hashfree(sh.var_tree))
#define nv_search(name,root,mode)	((Namval_t*)hashlook((Hashtab_t*)(root),name,(mode)^HASH_SCOPE,(char*)0))
#ifdef SHOPT_OO
#   define nv_class(np)		(nv_isattr(np,NV_IMPORT)?0:(Namval_t*)((np)->nvenv))
#endif /* SHOPT_OO */

/* The following are operations for associative arrays */
#define NV_AINIT	1	/* initialize */
#define NV_AFREE	2	/* free array */
#define NV_ANEXT	3	/* advance to next subscript */
#define NV_ANAME	4	/* return subscript name */
#define NV_ADELETE	5	/* delete current subscript */
#define NV_AADD		6	/* add subscript if not found */

/* The following are operations for nv_putsub() */
#define ARRAY_BITS	16
#define ARRAY_ADD	(1L<<ARRAY_BITS)	/* add subscript if not found */
#define	ARRAY_SCAN	(2L<<ARRAY_BITS)	/* For ${array[@]} */
#define ARRAY_UNDEF	(4L<<ARRAY_BITS)	/* For ${array} */

/* prototype for array interface*/
extern __MANGLE__ Namarr_t	*nv_setarray __PROTO__((Namval_t*,__V_*(*)(Namval_t*,const char*,int)));
extern __MANGLE__ __V_	*nv_associative __PROTO__((Namval_t*,const char*,int));
extern __MANGLE__ int	nv_aindex __PROTO__((Namval_t*));
extern __MANGLE__ int	nv_nextsub __PROTO__((Namval_t*));
extern __MANGLE__ char	*nv_getsub __PROTO__((Namval_t*));
extern __MANGLE__ Namval_t	*nv_putsub __PROTO__((Namval_t*, char*, long));

/* name-value pair function prototypes */
extern __MANGLE__ void 	nv_close __PROTO__((Namval_t*));
extern __MANGLE__ Namval_t *nv_create __PROTO__((Namval_t*,const char*,Namfun_t*));
extern __MANGLE__ double 	nv_getn __PROTO__((Namval_t*, Namfun_t*));
extern __MANGLE__ double 	nv_getnum __PROTO__((Namval_t*));
extern __MANGLE__ Hashtab_t *nv_getscope __PROTO__((int));
extern __MANGLE__ char 	*nv_getv __PROTO__((Namval_t*, Namfun_t*));
extern __MANGLE__ char 	*nv_getval __PROTO__((Namval_t*));
extern __MANGLE__ void 	nv_newattr __PROTO__((Namval_t*,unsigned,int));
extern __MANGLE__ Namval_t	*nv_open __PROTO__((const char*,Hashtab_t*,int));
extern __MANGLE__ void 	nv_putval __PROTO__((Namval_t*,const char*,int));
extern __MANGLE__ void 	nv_putv __PROTO__((Namval_t*,const char*,int,Namfun_t*));
extern __MANGLE__ int	nv_scan __PROTO__((Hashtab_t*,void(*)(Namval_t*),int,int));
extern __MANGLE__ Namval_t	*nv_scoped __PROTO__((Namval_t*));
extern __MANGLE__ char 	*nv_setdisc __PROTO__((Namval_t*,const char*,Namval_t*,Namfun_t*));
extern __MANGLE__ void	nv_setref __PROTO__((Namval_t*));
extern __MANGLE__ void 	nv_setvec __PROTO__((Namval_t*,int,char*[]));
extern __MANGLE__ void	nv_setvtree __PROTO__((Namval_t*));
extern __MANGLE__ Namfun_t *nv_stack __PROTO__((Namval_t*,Namfun_t*));
extern __MANGLE__ void 	nv_unset __PROTO__((Namval_t*));

#if 0
/*
 * The names of many functions were changed in early '95
 * Here is a mapping to the old names
 */
#   define nv_istype(np)	nv_isattr(np)
#   define nv_newtype(np)	nv_newattr(np)
#   define nv_namset(np,a,b)	nv_open(np,a,b)
#   define nv_free(np)		nv_unset(np)
#   define nv_settype(np,a,b,c)	nv_setdisc(np,a,b,c)
#   define nv_search(np,a,b)	nv_open(np,a,((b)?0:NV_NOADD))
#   define settype	setdisc
#endif

#endif /* NV_DEFAULT */
