/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: arith.c /main/3 1995/11/01 16:45:38 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Advanced Software Technology Department            *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                    {research,attmail}!dgk                    *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
#include	"defs.h"
#include	<ctype.h>
#include	"lexstates.h"
#include	"name.h"
#include	"streval.h"
#include	"FEATURE/locale"

static int level;
static double arith __PARAM__((const char **ptr, struct lval *lvalue, int type, double n), (ptr, lvalue, type, n)) __OTORP__(const char **ptr; struct lval *lvalue; int type; double n;){
	double r= 0;
	char *str = (char*)*ptr;
	switch(type)
	{
	    case ASSIGN:
	    {
		Namval_t *np = (Namval_t*)(lvalue->value);
		Namarr_t *ap;
		if(ap = nv_arrayptr(np))
		{
			if(!array_assoc(ap))
				nv_putsub(np, NIL(char*),lvalue->flag);
		}
		nv_putval(np, (char*)&n, NV_INTEGER);
		break;
	    }
	    case LOOKUP:
	    {
		int c = *str;
		lvalue->value = (char*)0;
		if(c=='.')
			c = str[1];
		if(isaletter(c))
		{
			Namval_t *np;
			while(c= *++str, isaname(c)||c=='.');
			if(c=='(')
			{
				int fsize = str- (char*)(*ptr);
				const struct mathtab *tp;
				c = **ptr;
				lvalue->fun = 0;
				for(tp=shtab_math; *tp->fname; tp++)
				{
					if(*tp->fname > c)
						break;
					if(*tp->fname==c && strncmp(tp->fname,*ptr,fsize)==0 && (fsize==4 || tp->fname[fsize]==0))
					{
						lvalue->fun = tp->fnptr;
						break;
					}
				}
				if(lvalue->fun)
					break;
				lvalue->value = (char*)e_function;
				return(r);
			}
			*str = 0;
			np = nv_open(*ptr,sh.var_tree,NV_NOASSIGN|NV_VARNAME);
			*str = c;
			if(nv_isattr(np,NV_INTEGER|NV_DOUBLE)==(NV_INTEGER|NV_DOUBLE))
				lvalue->isfloat=1;
			if(c=='[')
				str = nv_endsubscript(np,str,NV_ADD);
			else if(nv_isattr(np,NV_ARRAY))
				nv_putsub(np,NIL(char*),ARRAY_UNDEF);
			lvalue->value = (char*)np;
			lvalue->flag = nv_aindex(np);
		}
		else
		{
			char	*val = str;
			sh.lastbase = 1;
			r = strton(val,&str, &sh.lastbase,-1);
			if(sh.lastbase<=1)
				sh.lastbase=10;
			if((c= *str)==GETDECIMAL(0) || c=='e' || c == 'E')
			{
				lvalue->isfloat=1;
				r = strtod(val,&str);
			}
		}
		break;
	    }
	    case VALUE:
	    {
		Namval_t *np = (Namval_t*)(lvalue->value);
		if(sh_isoption(SH_NOEXEC))
			return(0);
		if((level || sh_isoption(SH_NOUNSET)) && nv_isnull(np) && !nv_isattr(np,NV_INTEGER))
		{
			*ptr = nv_name(np);
			lvalue->value = (char*)e_notset+4;
			return(0);
		}
		level++;
		r = nv_getnum(np);
		level--;
		return(r);
	    }

	    case ERRMSG:
		level=0;
		error(ERROR_exit(1),lvalue->value,*ptr);
	}
	*ptr = str;
	return(r);
}

double sh_strnum __PARAM__((const char *str, char** ptr), (str, ptr)) __OTORP__(const char *str; char** ptr;){
	return(strval(str,(char**)ptr, arith));
}

double sh_arith __PARAM__((const char *str), (str)) __OTORP__(const char *str;){
	const char *ptr = str;
	double d;
	if(*str==0)
		return(0);
	d = strval(str,(char**)&ptr,arith);
	if(*ptr)
		error(ERROR_exit(1),e_lexbadchar,*ptr,str);
	return(d);
}

