/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: name.c /main/4 1996/11/07 16:19:40 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Advanced Software Technology Department            *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                    {research,attmail}!dgk                    *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
#include	"defs.h"
#include	<ctype.h>
#include	"variables.h"
#include	"path.h"
#include	"lexstates.h"
#include	"timeout.h"
#include	"FEATURE/locale"
#include	"national.h"

static void	attstore __PROTO__((Namval_t*));
static void	pushnam __PROTO__((Namval_t*));
static char	*staknam __PROTO__((Namval_t*, char*));
static void	utol __PROTO__((const char*,char*));
static void	ltou __PROTO__((const char*,char*));
static void	rightjust __PROTO__((char*, int, int));

static char	**argnam;
static int	attsize;
static char	*attval;
static char	forced;
static char	local;
static void(*nullscan) __PROTO__((Namval_t*));

/* ========	name value pair routines	======== */

#include	"shnodes.h"
#include	"builtins.h"

/*
 * necessary to force linking to system putenv.  Otherwise putenv is defined
 * to be "setenv" which is resolved in libast.a
 */
#undef putenv

extern char *getenv();

/*
 * Remove an element from the environ array.  Code mostly taken from
 * DtEnvRemove, but this code does pointer comparisons rather than
 * strcmp calls, and does not free anything.
 */
extern char     **environ;
int remove_env_entry __PARAM__((char *pEntry), (pEntry)) __OTORP__(char *pEntry;)
{
        char **pEnviron, **pEnviron2 = (char **)environ;
        char *p;
        int temp;

        int count  = 0;  /* count is the number of items in the */
                         /* environ                             */
        int index;   /* index will range from 0 to count - 1 */
        int len;

        if (!(len = strlen(pEntry)))
                return(1);

        pEnviron = pEnviron2;

        p = *pEnviron;

        while (p)
        {
                pEnviron++;
                count++;
                p = *pEnviron;
        }

        pEnviron = pEnviron2;
        p = *pEnviron;

        for  (index = 0; index < count; index++)
        {
                if (p == pEntry)
                {
                    for (temp = index; temp != count - 1; temp++)
                    {
                            pEnviron2[temp] = pEnviron2[temp + 1];
                    }
                    pEnviron2[count - 1] = NULL;
                    return(0);
                }
                pEnviron++;
                p = *pEnviron;
        }
        return(1);
}

/*
 * Utility to mirror changes in our environment hash table into the
 * environment seen by library routines in internally-linked libc
 * libraries.
 */
void mirror_env __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;)
{
        char *buf, *val = nv_getval(np), *name = nv_name(np);
        int freeIt = 0;

	/*
	 * CDExc22516: Under some circumstances, dtksh's environ
	 * is NULL on Fujitsu.  This in itself may be a problem
	 * that should be researched, but for now, we simply
	 * protect against using putenv/getenv if environ is
	 * NULL.  rswiston@x.org 11/07/96
	 *
	 * Safe for removal? Fujitsu is no longer supported 05/15/18 - C
	 */
        if((name != (char *)NULL) && (environ != (char **)NULL))
        {
                /*
                * This is funky, but I'm not confident that I fully understand the
                * use/reuse patterns of the NamVal_t structs.  This code ensures
                * that we only free up environment variables that we are replacing.
                */
                if((np->nvdtenv != (char *)NULL) &&
                (getenv(name) == (np->nvdtenv + strlen(name) + 1)))
                                freeIt = 1;

                if(val != (char *)NULL)
                        buf = (char *)malloc(strlen(name) + strlen(val) + 2);
                else
                        buf = (char *)malloc(strlen(name) + 2);
                strcpy(buf, name);
                strcat(buf, "=");
                if(val != (char *)NULL)
                        strcat(buf, val);

                putenv(buf);
                if(freeIt == 1)
                        free((__V_*)np->nvdtenv);
                np->nvdtenv = buf;
        }
}


/*
 * Perform parameter assignment for a linked list of parameters
 * <flags> contains attributes for the parameters
 */
void nv_setlist __PARAM__((struct argnod *arg,int flags), (arg, flags)) __OTORP__(struct argnod *arg;int flags;){
	char *cp;
	Namval_t *np;
	int traceon = (sh_isoption(SH_XTRACE)!=0);
	if(sh_isoption(SH_ALLEXPORT))
		flags |= NV_EXPORT;
	if(sh.prefix)
	{
		flags &= ~(NV_IDENT|NV_EXPORT);
		flags |= NV_VARNAME;
	}
	for(;arg; arg=arg->argnxt.ap)
	{
		sh.used_pos = 0;
		if(arg->argflag&ARG_MAC)
			cp = sh_mactrim(arg->argval,-1);
		else
		{
			stakseek(0);
			if(*arg->argval==0)
			{
				int flag = (NV_VARNAME|NV_ARRAY|NV_ASSIGN);
				struct fornod *fp=(struct fornod*)arg->argchn.ap;
				union anynode *tp=fp->fortre;
				char *prefix = sh.prefix;
				cp = fp->fornam;
				error_info.line = fp->fortyp-sh.st.firstline;
				if(sh.fn_depth && (Namval_t*)tp->com.comnamp==SYSTYPESET)
			                flag |= NV_NOSCOPE;
				np = nv_open(cp,sh.var_tree,flag);
				nv_unset(np);
				/* check for array assignment */
				if(tp->tre.tretyp!=TLST && !tp->com.comset)
				{
					int argc;
					char **argv = sh_argbuild(&argc,&tp->com);
					nv_setvec(np,argc,argv);
					if(traceon)
					{
						sh_trace(NIL(char**),0);
						sfputr(sfstderr,nv_name(np),'=');
						sfwrite(sfstderr,"( ",2);
						while(cp= *argv++)
							sfputr(sfstderr,sh_fmtq(cp),' ');
						sfwrite(sfstderr,")\n",2);
					}
					continue;
				}
				if(tp->tre.tretyp==TLST || tp->com.comset->argval[0]!='[')
					nv_setvtree(np);
				else
					nv_setarray(np,nv_associative);
				if(prefix)
				{
					stakputs(prefix);
					stakputc('.');
					stakputs(cp);
					cp = stakfreeze(1);
				}
				sh.prefix = cp;
				sh_exec(tp,sh_isstate(SH_ERREXIT));
				sh.prefix = prefix;
				continue;
			}
			cp = arg->argval;
		}
		np = nv_open(cp,sh.var_tree,flags);
		if(sh.used_pos)
			np->nvsize |= NV_PARAM;
		else
			np->nvsize &= ~NV_PARAM;
		if(traceon)
		{
			char *sp=cp;
			sh_trace(NIL(char**),0);
			sfputr(sfstderr,nv_name(np),-1);
			if(nv_isattr(np,NV_ARRAY) && (cp=strchr(sp,'[')))
			{
				/* no quoting needed up to the = */
				sp = nv_endsubscript(np,cp,0);
				sfwrite(sfstderr,cp,sp -cp);
				cp = sp;
			}
			else
				cp = strchr(sp,'=');
			if(cp)
				sfprintf(sfstderr,"=%s\n",sh_fmtq(cp+1));
		}
	}
}

/*
 * construct a new name from a prefix and base name on the stack
 */
static char *newname __PARAM__((const char *prefix, const char *name), (prefix, name)) __OTORP__(const char *prefix; const char *name;){
	int offset = staktell();
	stakputs(prefix);
	if(*name!='[')
		stakputc('.');
	stakputs(name);
	stakputc(0);
	stakseek(offset);
	return(stakptr(offset));
}

/*
 * Put <arg> into associative memory.
 * If <flags> & NV_ARRAY then subscript is not allowed
 * If <flags> & NV_NOSCOPE then use the current scope only
 * If <flags> & NV_ASSIGN then assignment is allowed
 * If <flags> & NV_IDENT then name must be an identifier
 * If <flags> & NV_VARNAME then name must be a valid variable name
 * If <flags> & NV_NOADD then node will not be added if not found
 * SH_INIT is only set while initializing the environment
 */
Namval_t	*nv_open __PARAM__((const char *name,Hashtab_t *root,int flags), (name, root, flags)) __OTORP__(const char *name;Hashtab_t *root;int flags;){
	char *cp = (char*)name;
	Namval_t	*np=0;
	int sep = *cp;
	char *lastdot = 0;
	long mode = ((flags&NV_NOADD)?0:NV_ADD);
	if(root==sh.alias_tree)
	{
		while((sep= *(unsigned char*)cp) && (sep!='=') && (sep!='/') && 
			(!(sep=sh_lexstates[ST_NORM][sep]) || sep==S_EPAT))
			cp++;
	}
	else
	{
		if(!root)
			root = sh.var_tree;
		if(!(flags&(NV_IDENT|NV_VARNAME|NV_ASSIGN)))
		{
			if(flags&NV_NOSCOPE)
				mode |= HASH_SCOPE|HASH_NOSCOPE;
			np = nv_search(name,root,mode);
			if(np && !(flags&NV_REF))
			{
				while(nv_isattr(np,NV_REF))
					np=np->nvalue.np;
			}
			return(np);
		}
		if(sh.prefix && (flags&NV_ASSIGN))
			name = cp = newname(sh.prefix,name);
		/* first skip over alpha-numeric */
		while(1)
		{
			if(sep=='.')
			{
				if(flags&NV_IDENT)
					goto failed;
				if(root==sh.var_tree)
					flags &= ~(NV_NOSCOPE|NV_EXPORT);
				if(!lastdot && cp!=name && (flags&NV_VARNAME))
				{
					/* see whether first component is ref */
					*cp = 0;
					np = nv_search(name,sh.var_tree,0);
					*cp = '.';
					if(np && nv_isattr(np,NV_REF))
					{
						/* substitute ref name */
						while(nv_isattr(np,NV_REF))
							np=np->nvalue.np;
						name = nv_name(np);
						sep = strlen(name);
						name=lastdot=newname(name,cp+1);
						cp = lastdot + sep +1;
					}
					else
						lastdot = cp++;
				}
				else
					lastdot = cp++;
			}
			if(sep= *(unsigned char*)cp, !isaletter(sep))
				break;
			while(sep= *(unsigned char*)(++cp),isaname(sep));
		}
		/* if name doesn't have to be an varname or ident skip to '=' */
#ifdef SHOPT_APPEND
		if(sep && sep!='=' && sep!='[' && sep!='+')
#else
		if(sep && sep!='=' && sep!='[')
#endif /* SHOPT_APPEND */
		{
			if(flags&NV_IDENT)
				goto failed;
			else if(flags&NV_VARNAME)
				error(ERROR_exit(1),(root==sh.var_tree?e_varname:e_funname),name);
			while((sep= *++cp) && sep!='=');
		}
		if(lastdot)
			np = nv_search(name,root,0);
		while(!np && lastdot && lastdot>name)
		{
			*lastdot=0;
			np = nv_search(name,sh.var_tree,0);
			*lastdot='.';
			if(np)
			{
				char *sp;
				Namval_t *nq;
				if(np->nvfun && (np->nvfun)->disc->create)
				{
					*cp = 0;
					np = nv_create(nq=np,lastdot+1,(Namfun_t*)np);
					*cp = sep;
					if(np==nq)
						error(ERROR_exit(1),e_varname,name);
				}
				else if((sp=strchr(lastdot+1,'.')) && sp<cp)
					error(ERROR_exit(1),e_noparent,name);
				else
					np = 0;
				break;
			}
			while(--lastdot>name && *lastdot!='.');
			if(lastdot==name || (!np && root!=sh.var_tree))
				error(ERROR_exit(1),e_noparent,name);
		}
	}
	if(cp!=name)
	{
		if(sep)
			*cp = 0;
		if((flags&NV_NOSCOPE) && hashscope(root) && root==sh.var_tree 
			&& (np=nv_search(name,sh.var_base,0)))
		{
			Namfun_t *disc = nv_cover(np);
			if(np=nv_search((char*)np,root,mode|HASH_NOSCOPE|HASH_SCOPE|HASH_BUCKET))
				np->nvfun = disc;
		}
		else if(!np)
		{
			if(flags&NV_NOSCOPE)
				mode |= HASH_SCOPE|HASH_NOSCOPE;
			np = nv_search(name,root,mode);
		}
		if(sep)
			*cp = sep;
		if((flags&NV_REF) || (!np && (flags&NV_NOADD)))
			return(np);
		while(nv_isattr(np,NV_REF))
			np=np->nvalue.np;
		/* check for subscript*/
		if(sep=='[' && !(flags&NV_ARRAY))
		{
			sep = (flags&NV_ASSIGN?NV_ADD:0);
			cp = nv_endsubscript(np,cp,NV_ADD);
			sep = *cp;
		}
		else if(nv_isattr(np,NV_ARRAY))
			nv_putsub(np,NIL(char*),ARRAY_UNDEF);
#ifdef SHOPT_APPEND
		if(sep=='+')
			sep = *++cp;
#endif /* SHOPT_APPEND */
		if(sep && ((sep!='=')||!(flags&NV_ASSIGN)))
		{
			if(sh_isstate(SH_INIT))
				return(0);
			goto failed;
		}
		if(root==sh.alias_tree)
		{
			if(nv_isattr(np,NV_TAGGED|NV_NOALIAS))
				nv_offattr(np,(NV_NOALIAS|NV_TAGGED|NV_EXPORT));
		}
		if(sep == '=')
		{
			cp++;
			if(sh_isstate(SH_INIT))
			{
				nv_putval(np, cp, NV_RDONLY);
				if(np==PWDNOD)
					nv_onattr(np,NV_TAGGED);
			}
			else
			{
				nv_putval(np, cp, 0);
#ifdef SHOPT_BSH
				if(flags&NV_EXPORT)
					nv_offattr(np,NV_IMPORT);
#endif /* SHOPT_BSH */
			}
			nv_onattr(np, flags&NV_ATTRIBUTES);

                        /*
                         * Set environment variable defined in the underlying
                         * libc environ. This is done because routines within
                         * a shared libc will only look in the libc environ,
                         * not in our hash trees to find environment variables.
                         */
                        if(nv_isattr(np,NV_EXPORT))
                                mirror_env(np);
		}
		return(np);
	}
failed:
	if(!sh_isstate(SH_INIT))
		error(ERROR_exit(1),(root==sh.alias_tree?e_aliname:e_ident),name);
	return(0);
}

#ifdef SHOPT_MULTIBYTE
    static char *savep;
    static char savechars[ESS_MAXCHAR+1];
    static int ja_size __PROTO__((char*, int, int));
    static void ja_restore __PROTO__((void));
#endif /* SHOPT_MULTIBYTE */

/*
 * put value <string> into name-value node <np>.
 * If <np> is an array, then the element given by the
 *   current index is assigned to.
 * If <flags> contains NV_RDONLY, readonly attribute is ignored
 * If <flags> contains NV_INTEGER, string is a pointer to a number
 * If <flags> contains NV_NOFREE, previous value is freed, and <string>
 * becomes value of node and <flags> becomes attributes
 */
void nv_putval __PARAM__((Namval_t *np, const char *string, int flags), (np, string, flags)) __OTORP__(Namval_t *np; const char *string; int flags;){
	const char *sp=string;
	union Value *up;
	char *cp;
	int size = 0;
	int dot;
	if(!(flags&NV_RDONLY) && nv_isattr (np, NV_RDONLY))
		error(ERROR_exit(1),e_readonly, nv_name(np));
	/* The following could cause the shell to fork if assignment
	 * would cause a side effect
	 */
	if(sh.subshell)
		np = sh_assignok(np,1);
	if(nv_isattr(np, NV_ARRAY))
		array_check(np,ARRAY_ASSIGN);
	if(np->nvfun)
	{
		/* This function contains disc */
		if(!local)
		{
			local=1;
			nv_putv(np,sp,flags,np->nvfun);
			return;
		}
		/* called from disc, assign the actual value */
		local=0;
	}
	if(flags&(NV_REF|NV_NOFREE))
	{
		nv_unset(np);
		np->nvalue.cp = (char*)sp;
		nv_setattr(np,flags|NV_NOFREE);
		return;
	}
	if(nv_isattr(np, NV_ARRAY))
		up = array_find(np,ARRAY_ASSIGN);
	else
		up= &np->nvalue;
#ifndef SHOPT_BSH
	nv_offattr(np,NV_IMPORT);
	np->nvenv = 0;
#endif /* SHOPT_BSH */
	if(nv_isattr (np, NV_INTEGER))
	{
		if(nv_isattr (np, NV_CPOINTER))
			up->cp = (char*)sp;
		else if(nv_isattr(np, NV_DOUBLE))
		{
			double d;
			if(flags&NV_INTEGER)
				d = *(double*)sp;
			else
				d = sh_arith(sp);
			if(!up->dp)
				up->dp = new_of(double,0);
			*(up->dp) = d;
		}
		else
		{
			long l = 0;
			if(flags&NV_INTEGER)
				l = *(double*)sp;
			else if(sp)
				l = (long)sh_arith(sp);
			else
				sh.lastbase = 10;
			if(nv_size(np) <= 1)
				nv_setsize(np,sh.lastbase);
			if(nv_isattr (np, NV_SHORT))
				up->s = (short)l;
			else
			{
				if(!up->lp)
					up->lp = new_of(long,0);
				*(up->lp) = l;
				if(l && *sp++ == '0')
					nv_onattr(np,NV_UNSIGN);
			}
		}
	}
	else
	{
		const char *tofree=0;
		if(flags&NV_INTEGER)
			sp = sh_etos(*((double*)sp),12);

		if((nv_isattr(np, NV_RJUST|NV_ZFILL|NV_LJUST)) && sp)
		{
			for(;*sp == ' '|| *sp=='\t';sp++);
	        	if((nv_isattr(np,NV_ZFILL)) && (nv_isattr(np,NV_LJUST)))
				for(;*sp=='0';sp++);
			size = nv_size(np);
#ifdef SHOPT_MULTIBYTE
			if(size)
				size = ja_size((char*)sp,size,nv_isattr(np,NV_RJUST|NV_ZFILL));
#endif /* SHOPT_MULTIBYTE */
		}
		if(!nv_isattr(np, NV_NOFREE|NV_NOALLOC))
		{
			/* delay free in case <sp> points into free region */
			tofree = up->cp;
		}
		if(nv_isattr(np, NV_NOALLOC))
			cp = (char*)up->cp;
		else
		{
			nv_offattr(np,NV_NOFREE);
       		 	if (sp)
			{
				dot = strlen(sp);
				if(size==0 && nv_isattr(np,NV_LJUST|NV_RJUST|NV_ZFILL))
					nv_setsize(np,size=dot);
				else if(size > dot)
					dot = size;
				cp = (char*)malloc(((unsigned)dot+1));
			}
			else
				cp = 0;
			up->cp = cp;
		}
		if(sp)
		{
			if(nv_isattr(np, NV_LTOU))
				ltou(sp,cp);
			else if(nv_isattr (np, NV_UTOL))
				utol(sp,cp);
			else
       			 	strcpy(cp, sp);
			if(nv_isattr(np, NV_RJUST) && nv_isattr(np, NV_ZFILL))
				rightjust(cp,size,'0');
			else if(nv_isattr(np, NV_RJUST))
				rightjust(cp,size,' ');
			else if(nv_isattr(np, NV_LJUST))
			{
				char *dp;
				dp = strlen (cp) + cp;
				*(cp = (cp + size)) = 0;
				for (; dp < cp; *dp++ = ' ');
			 }
#ifdef SHOPT_MULTIBYTE
			/* restore original string */
			if(savep)
				ja_restore();
#endif /* SHOPT_MULTIBYTE */
		}
		if(tofree)
			free((__V_*)tofree);
	}
        /*
         * Set environment variable defined in the underlying
         * libc environ. This is done because routines within
         * a shared libc will only look in the libc environ,
         * not in our hash trees to find environment variables.
         */
        if((flags&NV_RDONLY) && nv_isattr(np,NV_EXPORT))
                mirror_env(np);
	return;
}

/*
 *
 *   Right-justify <str> so that it contains no more than
 *   <size> characters.  If <str> contains fewer than <size>
 *   characters, left-pad with <fill>.  Trailing blanks
 *   in <str> will be ignored.
 *
 *   If the leftmost digit in <str> is not a digit, <fill>
 *   will default to a blank.
 */
static void rightjust __PARAM__((char *str, int size, int fill), (str, size, fill)) __OTORP__(char *str; int size; int fill;){
	int n;
	char *cp,*sp;
	n = strlen(str);

	/* ignore trailing blanks */
	for(cp=str+n;n && *--cp == ' ';n--);
	if (n == size)
		return;
	if(n > size)
        {
        	*(str+n) = 0;
        	for (sp = str, cp = str+n-size; sp <= str+size; *sp++ = *cp++);
        	return;
        }
	else *(sp = str+size) = 0;
	if (n == 0)  
        {
        	while (sp > str)
               		*--sp = ' ';
        	return;
        }
	while(n--)
	{
		sp--;
		*sp = *cp--;
	}
	if(!isdigit(*str))
		fill = ' ';
	while(sp>str)
		*--sp = fill;
	return;
}

#ifdef SHOPT_MULTIBYTE
    /*
     * handle left and right justified fields for multi-byte chars
     * given physical size, return a logical size which reflects the
     * screen width of multi-byte characters
     * Multi-width characters replaced by spaces if they cross the boundary
     * <type> is non-zero for right justified  fields
     */

    static int ja_size __PARAM__((char *str,int size,int type), (str, size, type)) __OTORP__(char *str;int size;int type;){
	char *cp = str;
	int c, n=size;
	int oldn;
	wchar_t w;
	while(*cp)
	{
		oldn = n;
		if((c=mbtowc(&w,cp,MB_CUR_MAX))>0)
		{
			int outsize =  wcwidth(w);
			/* allow room for excess input bytes */
			n += (c-outsize);
			size -= outsize;
		}
		else
		{
			c = 1;
			size -=1;
		}
		if(size<=0 && type==0)
			break;
		cp += c;
	}
	/* check for right justified fields that need truncating */
	if(size <0)
	{
		if(type==0)
		{
			/* left justified and character crosses field boundary */
			n = oldn;
			/* save boundary char and replace with spaces */
			size = c;
			savechars[size] = 0;
			while(size--)
			{
				savechars[size] = cp[size];
				cp[size] = ' ';
			}
			savep = cp;
		}
		size = -size;
		if(type)
			n -= (ja_size(str,size,0)-size);
	}
	return(n);
    }

    static void ja_restore __PARAM__((void), ()){
	char *cp = savechars;
	while(*cp)
		*savep++ = *cp++;
	savep = 0;
    }
#endif /* SHOPT_MULTIBYTE */

static char *staknam __PARAM__((Namval_t *np, char *value), (np, value)) __OTORP__(Namval_t *np; char *value;){
	char *p,*q;
	q = stakalloc(strlen(nv_name(np))+(value?strlen(value):0)+2);
	p=strcopy(q,nv_name(np));
	if(value)
	{
		*p++ = '=';
		strcpy(p,value);
	}
	return(q);
}

/*
 * put the name and attribute into value of attributes variable
 */
static void attstore __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	int flag = np->nvflag;
	if(!(flag&NV_EXPORT) || (flag&NV_FUNCT))
		return;
	flag &= (NV_RDONLY|NV_UTOL|NV_LTOU|NV_RJUST|NV_LJUST|NV_ZFILL|NV_INTEGER);
	*attval++ = '=';
	*attval++ = ' '+flag;
	if(flag&NV_INTEGER)
		*attval = ' ' + nv_size(np);
	else
		*attval = ' ';
	attval = strcopy(++attval,nv_name(np));
}

static void pushnam __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	char *value;
	if(nv_isattr(np,NV_IMPORT))
	{
		if(np->nvenv)
			*argnam++ = np->nvenv;
	}
	else if(value=nv_getval(np))
		*argnam++ = staknam(np,value);
	if(nv_isattr(np,NV_RDONLY|NV_UTOL|NV_LTOU|NV_RJUST|NV_LJUST|NV_ZFILL|NV_INTEGER))
		attsize += (strlen(nv_name(np))+4);
}

/*
 * Generate the environment list for the child.
 */

char **sh_envgen __PARAM__((void), ()){
	char **er;
	int namec;
	char *cp;
	/* L_ARGNOD gets generated automatically as full path name of command */
	nv_offattr(L_ARGNOD,NV_EXPORT);
	attsize = 6;
	namec = nv_scan(sh.var_tree,nullscan,NV_EXPORT,NV_EXPORT);
	er = (char**)stakalloc((namec+3)*sizeof(char*));
	argnam = ++er;
	nv_scan(sh.var_tree, pushnam, NV_EXPORT, NV_EXPORT);
	*argnam = (char*)stakalloc(attsize);
	cp = attval = strcopy(*argnam,e_envmarker);
	nv_scan(sh.var_tree, attstore,0,(NV_RDONLY|NV_UTOL|NV_LTOU|NV_RJUST|NV_LJUST|NV_ZFILL|NV_INTEGER));
	*attval = 0;
	if(cp!=attval)
		argnam++;
	*argnam = 0;
	return(er);
}

static void (*scanfn) __PROTO__((Namval_t*));
static int scanmask;
static int scanflags;
static int scancount = 0;

static int scanfilter __PARAM__((const char *name, char *arg, __V_ *notused), (name, arg, notused)) __OTORP__(const char *name; char *arg; __V_ *notused;){
	Namval_t *np = (Namval_t*)arg;
	int k=np->nvflag;
	NOT_USED(name);
	NOT_USED(notused);
	if(scanmask?(k&scanmask)==scanflags:(!scanflags || (k&scanflags)))
	{
		if(!np->nvalue.cp && !nv_isattr(np,~NV_DEFAULT))
			return(0);
		if(scanfn)
		{
			if(nv_isattr(np,NV_ARRAY))
				nv_putsub(np,NIL(char*),0L);
			(*scanfn)(np);
		}
		scancount++;
	}
	return(0);
}

/*
 * Walk through the name-value pairs
 * if <mask> is non-zero, then only nodes with (nvflags&mask)==flags
 *	are visited
 * If <mask> is zero, and <flags> non-zero, then nodes with one or
 *	more of <flags> is visited
 * If <mask> and <flags> are zero, then all nodes are visted
 */
int nv_scan __PARAM__((Hashtab_t *root, void (*fn)(Namval_t*), int mask, int flags), (root, fn, mask, flags)) __OTORP__(Hashtab_t *root; void (*fn)(); int mask; int flags;){
	int (*hashfn) __PROTO__((const char*, char*, __V_*));
	scanmask = mask;
	scanflags = flags;
	scanfn = fn;
	hashfn = scanfilter;
	scancount = 0;
	hashwalk(root, 0, hashfn,NIL(char*));
	return(scancount);
}

/*
 * create a new environment scope
 */
void nv_scope __PARAM__((struct argnod *envlist), (envlist)) __OTORP__(struct argnod *envlist;){
	Hashtab_t *newscope;
	newscope = hashalloc(sh.var_tree,HASH_set,HASH_SCOPE|HASH_ALLOCATE,0);
	sh.var_tree = newscope;
	nv_setlist(envlist,NV_EXPORT|NV_NOSCOPE|NV_IDENT|NV_ASSIGN);
}

/* 
 * Remove freeable local space associated with the nvalue field
 * of nnod. This includes any strings representing the value(s) of the
 * node, as well as its dope vector, if it is an array.
 */

void	sh_envnolocal  __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	if(nv_isattr(np,NV_EXPORT|NV_NOFREE))
	{
		if(nv_isattr(np,NV_REF))
		{
			nv_offattr(np,NV_NOFREE|NV_REF);
			np->nvalue.cp = 0;
		}
		return;
	}
	if(nv_isattr(np, NV_ARRAY))
		nv_putsub(np,NIL(char*),ARRAY_SCAN);
	forced = 1;
	nv_unset(np);
	forced = 0;
	nv_setattr(np,0);
}

/*
 * Currently this is a dummy, but someday will be needed
 * for reference counting
 */
void	nv_close __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	NOT_USED(np);
}

/*
 *
 *   Set the value of <np> to 0, and nullify any attributes
 *   that <np> may have had.  Free any freeable space occupied
 *   by the value of <np>.  If <np> denotes an array member, it
 *   will retain its attributes.
 */
void	nv_unset __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	union Value *up = &np->nvalue;
	Namarr_t *ap;
	if(!forced && nv_isattr (np,NV_RDONLY))
		error(ERROR_exit(1),e_readonly, nv_name(np));
	if(sh.subshell && !nv_isnull(np))
		np = sh_assignok(np,0);
	if(ap = nv_arrayptr(np))
		array_check(np,ARRAY_DELETE);
	if(np->nvfun)
	{
		/* This function contains disc */
		if(!local)
		{
			local=1;
			nv_putv(np,NIL(char*),forced?NV_RDONLY:0,np->nvfun);
			return;
		}
		/* called from disc, assign the actual value */
		local=0;
	}
	forced = 0;
	do
	{
		if(ap)
		{
			if(!(up=array_find(np,ARRAY_DELETE)))
				return;
		}
		if((!nv_isattr (np, NV_NOFREE)) && up->cp)
			free((__V_*)up->cp);
		up->cp = 0;
	}
	while(ap?nv_nextsub(np):0);
	if(!nv_isattr(np,NV_ARRAY))
	{
		nv_setattr(np,0);
		nv_setsize(np,0);
		np->nvenv = 0;
	}
        /* dtksh-specific code to sync hash table & environ */
        if(np->nvdtenv != (char *)NULL)
        {
                remove_env_entry(np->nvdtenv);
                free((__V_*)np->nvdtenv);
                np->nvdtenv = (char *)NULL;
        }
}

/*
 * return the node pointer in the highest level scope
 */
Namval_t *nv_scoped __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	if(hashscope(sh.var_tree))
		return(nv_search((char*)np,sh.var_tree,HASH_BUCKET));
	else
		return(np);
}

/*
 *   Return a pointer to a character string that denotes the value
 *   of <np>.  If <np> refers to an array,  return a pointer to
 *   the value associated with the current index.
 *
 *   If the value of <np> is an integer, the string returned will
 *   be overwritten by the next call to nv_getval.
 *
 *   If <np> has no value, 0 is returned.
 */

char *nv_getval __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	union Value *up= &np->nvalue;
	int numeric;
	Namarr_t *ap;
	if(!np->nvfun && !nv_isattr(np,NV_ARRAY|NV_INTEGER|NV_FUNCT|NV_REF))
		goto done;
	if(ap = nv_arrayptr(np))
		array_check(np,ARRAY_LOOKUP);
	if(np->nvfun)
	{
		if(!local)
		{
			local=1;
			return(nv_getv(np, np->nvfun));
		}
		local=0;
	}
	numeric = ((nv_isattr (np, NV_INTEGER)) != 0);
	if(ap)
	{
		if(!(up = array_find(np,ARRAY_LOOKUP)))
	        	return (NIL(char*));
	}
	if(numeric)
	{
		long l;
        	if(!up->cp || nv_isattr (np,NV_CPOINTER))
			return((char*)up->cp);
		else if(nv_isattr (np,NV_DOUBLE))
		{
			double d = *up->dp;
			if(nv_isattr (np,NV_EXPNOTE))
				return(sh_etos(d,nv_size(np)));
			else
				return(sh_ftos(d,nv_size(np)));
		}
        	else if(nv_isattr (np,NV_SHORT))
			l = up->s;
        	else
			l = *(up->lp);
		if((numeric=nv_size(np))==10 && !nv_isattr(np,NV_UNSIGN))
			numeric = 0;
		return(fmtbase(l,numeric, numeric&&numeric!=10));
	}
	if(nv_isattr(np,NV_REF))
		return(nv_name(up->np));
done:
#ifdef SHOPT_OO
	/* This is not nearly complete */
	if(!up->cp && (np=nv_class(np)))
		return(nv_getval(np));
#endif /* SHOPT_OO */
	return ((char*)up->cp);
}

double nv_getnum __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	union Value *up;
	double r=0;
	char *str;
     	if(np->nvfun)
	{
		if(!local)
		{
			local=1;
			return(nv_getn(np, np->nvfun));
		}
		local=0;
	}
     	if(nv_isattr (np, NV_INTEGER))
	{
		if(nv_isattr(np, NV_ARRAY))
			up = array_find(np,ARRAY_ASSIGN);
		else
			up= &np->nvalue;
		if(!up->lp)
			r = 0;
		else if(nv_isattr(np, NV_DOUBLE))
                       	r = *up->dp;
		else
                       	r = *up->lp;
	}
	else if((str=nv_getval(np)) && *str!=0)
		r = sh_arith(str);
	return(r);
}
/*
 *   Give <np> the attributes <newatts,> and change its current
 *   value to conform to <newatts>.  The <size> of left and right
 *   justified fields may be given.
 */
void nv_newattr  __PARAM__((Namval_t *np, unsigned newatts, int size), (np, newatts, size)) __OTORP__(Namval_t *np; unsigned newatts; int size;){
	char *sp;
	char *cp = 0;
	unsigned int n;
	Namarr_t *ap = 0;
	int oldsize,oldatts;

	/* check for restrictions */
	if(sh_isoption(SH_RESTRICTED) && ((sp=nv_name(np))==nv_name(PATHNOD) || sp==nv_name(SHELLNOD) || sp==nv_name(ENVNOD) ))
		error(ERROR_exit(1),e_restricted,nv_name(np));
	/* handle attributes that do not change data separately */
	n = np->nvflag;
#ifdef SHOPT_BSH
	if(newatts&NV_EXPORT)
		nv_offattr(np,NV_IMPORT);
#endif /* SHOPT_BSH */

        /*
         * Set environment variable defined in the underlying
         * libc environ. This is done because routines within
         * a shared libc will only look in the libc environ,
         * not in our hash trees to find environment variables.
         */
        if(newatts&NV_EXPORT)
                mirror_env(np);

	if((size==0||(n&NV_INTEGER)) && ((n^newatts)&~NV_NOCHANGE)==0)
	{
		if(size)
			nv_setsize(np,size);
		nv_offattr(np, ~NV_NOFREE);
		nv_onattr(np, newatts);
		return;
	}
	/* for an array, change all the elements */
	if((ap=nv_arrayptr(np)) && ap->nelem>0)
		nv_putsub(np,NIL(char*),ARRAY_SCAN);
	oldsize = nv_size(np);
	oldatts = np->nvflag;
	do
	{
		nv_setsize(np,oldsize);
		np->nvflag = oldatts;
		if (sp = nv_getval(np))
 		{
			cp = (char*)malloc((n=strlen (sp)) + 1);
			strcpy(cp, sp);
			if(ap)	/* add element to prevent array deletion */
			{
				ap->nelem &= ~ARRAY_SCAN;
				ap->nelem++;
			}
			nv_unset(np);
			if(ap)
			{
				ap->nelem--;
				ap->nelem |= ARRAY_SCAN;
			}
			if(size==0 && (newatts&(NV_LJUST|NV_RJUST|NV_ZFILL)))
				size = n;
		}
		else
			nv_unset(np);
		nv_setsize(np,size);
		np->nvflag &= NV_ARRAY;
		np->nvflag |= newatts;
		if (cp)
		{
			nv_putval (np, cp, NV_RDONLY);
			free(cp);
		}
	}
	while(ap && nv_nextsub(np));
	return;
}

#ifndef _NEXT_SOURCE
static char *oldgetenv __PARAM__((const char *string), (string)) __OTORP__(const
 char *string;){
        char c0,c1;
        const char *cp, *sp;
        char **av = environ;
        if(!string || (c0= *string)==0)
                return(0);
        if((c1= *++string)==0)
                c1= '=';
        while(cp = *av++)
        {
                if(cp[0]!=c0 || cp[1]!=c1)
                        continue;
                sp = string;
                while(*sp && *sp++ == *++cp);
                if(*sp==0 && *++cp=='=')
                        return((char*)(cp+1));
        }
        return(0);
}

/*
 * This version of getenv the hash storage to access environment values
 *
 * This had to be renamed to ksh_getenv to allow the dtksh code access to
 * the libc getenv. While some platforms support calling _getenv to work
 * around the problems, others don't.
 */
char *ksh_getenv __PARAM__((const char *name), (name)) __OTORP__(const char *name;){
        Namval_t *np;
        if(!sh.var_tree)
                return(oldgetenv(name));
        if((np = nv_search(name,sh.var_tree,0)) && nv_isattr(np,NV_EXPORT))
                return(nv_getval(np));
        return(0);
}
#endif /* _NEXT_SOURCE */

#undef putenv
/*
 * This version of putenv uses the hash storage to assign environment values
 *
 * The original ksh93 code had this routine called "putenv".  This hid
 * the libc version of putenv, which caused problems for dtksh on systems
 * with shared libraries, as it caused the existence of two separate and
 * non-overlapping environments.  To the best of my knowledge there are
 * no calls to this routine. - harry phinney  8/15/1994.
 */
int ksh_putenv __PARAM__((const char *name), (name)) __OTORP__(const char *name;){
	Namval_t *np;
	if(name)
	{
		np = nv_open(name,sh.var_tree,NV_EXPORT|NV_IDENT|NV_ARRAY|NV_ASSIGN);
		if(!strchr(name,'='))
			nv_unset(np);
	}
	return(0);
}


/*
 * Override libast setenv()
 */
char* setenviron __PARAM__((const char *name), (name)) __OTORP__(const char *name;){
	Namval_t *np;
	if(name)
	{
		np = nv_open(name,sh.var_tree,NV_EXPORT|NV_IDENT|NV_ARRAY|NV_ASSIGN);
		if(strchr(name,'='))
			return(nv_getval(np));
		nv_unset(np);
	}
	return("");
}

/*
 * copy <str1> to <str2> changing lower case to upper case
 * <str2> must be big enough to hold <str1>
 * <str1> and <str2> may point to the same place.
 */

static void ltou __PARAM__((char const *str1,char *str2), (str1, str2)) __OTORP__(char const *str1;char *str2;){
	int c;
	for(; c= *((unsigned char*)str1); str1++,str2++)
	{
		if(islower(c))
			*str2 = toupper(c);
		else
			*str2 = c;
	}
	*str2 = 0;
}

/*
 * copy <str1> to <str2> changing upper case to lower case
 * <str2> must be big enough to hold <str1>
 * <str1> and <str2> may point to the same place.
 */

static void utol __PARAM__((char const *str1,char *str2), (str1, str2)) __OTORP__(char const *str1;char *str2;){
	int c;
	for(; c= *((unsigned char*)str1); str1++,str2++)
	{
		if(isupper(c))
			*str2 = tolower(c);
		else
			*str2 = c;
	}
	*str2 = 0;
}

/*
 * Push or pop getval and putval functions to node <np>
 * <fp> is null to pop, otherwise, <fp> is pushed onto stack
 * The top of the stack is returned
 */
Namfun_t *nv_stack __PARAM__((Namval_t *np, Namfun_t* fp), (np, fp)) __OTORP__(Namval_t *np; Namfun_t* fp;){
        Namfun_t *lp;
        if(fp)
        {
                if((lp=np->nvfun)==fp)
                        return(fp);
                /* see if <fp> is on the list already and move to top */
                if(lp) while(lp->next)
                {
                        if(lp->next==fp)
                        {
                                lp->next = fp->next;
                                break;
                        }
                        lp = lp->next;
                }
                /* push */
                fp->next = np->nvfun;
                np->nvfun = fp;
        }
        else if(fp = np->nvfun)
                np->nvfun = fp->next;
        return(fp);
}

/*
 * add or replace built-in version of command commresponding to <path>
 * The <bltin> argument is a pointer to the built-in
 * Special builtins cannot be replaced and return -1
 */
int     sh_addbuiltin __PARAM__((const char *path, int (*bltin)(int, char*[],__V_*),__V_ *extra), (path, bltin, extra)) __OTORP__(const char *path; int (*bltin)();__V_ *extra;){
        const char *cp, *name = path_basename(path);
        Namval_t *np, *nq=0;
        if(name==path && (cp=strchr(name,'.')) && cp!=name)
        {
                int offset = staktell();
                stakwrite(name,cp-name);
                stakputc(0);
                nq=nv_open(stakptr(offset),0,NV_VARNAME|NV_NOARRAY);
                offset = staktell();
                stakputs(nv_name(nq));
                stakputs(cp);
                stakputc(0);
                path = name = stakptr(offset);
        }
        np = nv_search(name,sh.bltin_tree,NV_ADD);
        if(!np || nv_isattr(np,BLT_SPC))
                return(-1);
        if(np->nvenv && !nv_isattr(np,NV_NOFREE))
                free((__V_*)np->nvenv);
        np->nvenv = 0;
        np->nvfun = 0;
        nv_setattr(np,0);
        if(bltin)
        {
                np->nvalue.bfp = bltin;
                nv_onattr(np,NV_BLTIN);
                if(path!=name)
                        np->nvenv = strdup(path);
                np->nvfun = (Namfun_t*)extra;
        }
        if(nq)
        {
                cp=nv_setdisc(nq,cp+1,np,(Namfun_t*)nq);
                nv_close(nq);
                if(!cp)
                        error(ERROR_exit(1),e_baddisc,name);
        }
        return(0);
}

static	int maxbufsize;
static  char *curbuf;

/*
 *   Return a pointer to a string denoting the value of <val>
 *   with <places> places after the decimal point.  The string
 *   will be stored within static variable <numbuf>.
 */
char *sh_ftos __PARAM__((double val,int places), (val, places)) __OTORP__(double val;int places;){
	char *cp, *sp;
	int decpt,sign;

	cp = sffcvt(val,places,&decpt,&sign);
	if(decpt>0)
		places += decpt;
	places +=3;	/* room for sign, decimal point and null byte */
	if(!curbuf)
		curbuf = (char*)malloc(maxbufsize=places);
	else if(places > maxbufsize)
		curbuf = (char*)realloc(curbuf,maxbufsize=places);
	sp = curbuf;
	if(sign)
		*sp++ = '-';
	while(decpt-- > 0)
		*sp++ = *cp++;
	*sp++ = GETDECIMAL(0);
	while(++decpt < 0)
		*sp++  = '0';
	while(*sp++ = *cp++);
	return(curbuf);
}

/*
 * convert <val> to a string with <places> significant figures
 * The result is placed in a local buffer and a pointer returned
 */
char *sh_etos __PARAM__((double val,int places), (val, places)) __OTORP__(double val;int places;){
	int bufsize = places+8;
	if(!curbuf)
		curbuf = (char*)malloc(maxbufsize=bufsize);
	else if(bufsize > maxbufsize)
		curbuf = (char*)realloc(curbuf,maxbufsize=bufsize);
	sfsprintf(curbuf,bufsize,"%.*g",places,val);
	return(curbuf);
}

/*
 * call the next getval function in the chain
 */
char *nv_getv __PARAM__((Namval_t *np, Namfun_t *nfp), (np, nfp)) __OTORP__(Namval_t *np; Namfun_t *nfp;){
	Namfun_t	*fp;
	char *cp;
	if((fp = nfp) != NIL(Namfun_t*) && !local)
		fp = nfp = nfp->next;
	local=0;
	while(fp && !fp->disc->getnum && !fp->disc->getval)
		fp = fp->next;
	if(fp)
		nfp = fp;
	if(nfp && nfp->disc->getval)
		cp = (*nfp->disc->getval)(np,nfp);
	else if(nfp && nfp->disc->getnum)
		cp = sh_etos((*nfp->disc->getnum)(np,nfp),12);
	else
	{
		local=1;
		cp = nv_getval(np);
	}
	return(cp);
}

/*
 * call the next getnum function in the chain
 */
double nv_getn __PARAM__((Namval_t *np, Namfun_t *nfp), (np, nfp)) __OTORP__(Namval_t *np; Namfun_t *nfp;){
	Namfun_t	*fp;
	double d=0;
	if((fp = nfp) != NIL(Namfun_t*) && !local)
		fp = nfp = nfp->next;
	local=0;
	while(fp && !fp->disc->getnum && !fp->disc->getval)
		fp = fp->next;
	if(fp)
		nfp = fp;
	if(nfp && nfp->disc->getnum)
		d = (*nfp->disc->getnum)(np,nfp);
	else if(nfp && nfp->disc->getval)
	{
		char *str = (*nfp->disc->getval)(np,nfp);
		if(str && *str)
			d = sh_arith(str);
	}
	else
	{
		local=1;
		d = nv_getnum(np);
	}
	return(d);
}

/*
 * call the next assign function in the chain
 */
void nv_putv __PARAM__((Namval_t *np, const char *value, int flags, Namfun_t *nfp), (np, value, flags, nfp)) __OTORP__(Namval_t *np; const char *value; int flags; Namfun_t *nfp;){
	Namfun_t	*fp;
	if((fp=nfp) != NIL(Namfun_t*) && !local)
		fp = nfp = nfp->next;
	local=0;
	while(fp && !fp->disc->putval)
		fp = fp->next;
	if(fp)
		nfp = fp;
	if(nfp && nfp->disc->putval)
		(*nfp->disc->putval)(np,value, flags, nfp);
	else
	{
		local=1;
		if(value)
			nv_putval(np, value, flags);
		else
			nv_unset(np);
	}
}

#define	LOOKUP		0
#define	ASSIGN		1
#define	UNASSIGN	2
#define BLOCKED		((Namval_t*)&local)

struct	vardisc
{
	Namfun_t	fun;
	Namval_t	*disc[3];
};

/*
 * free discipline if no more discipline functions
 */
static void chktfree __PARAM__((Namval_t *np, struct vardisc *vp), (np, vp)) __OTORP__(Namval_t *np; struct vardisc *vp;){
	int n;
	for(n=0; n< sizeof(vp->disc)/sizeof(*vp->disc); n++)
	{
		if(vp->disc[n])
			break;
	}
	if(n>=sizeof(vp->disc)/sizeof(*vp->disc))
	{
		/* no disc left so pop */
		Namfun_t *fp;
		if(fp=nv_stack(np, NIL(Namfun_t*)))
			free((__V_*)fp);
	}
}

/*
 * This function performs an assignment disc on the given node <np>
 */
static void	assign __PARAM__((Namval_t *np,const char* val,int flags,Namfun_t *handle), (np, val, flags, handle)) __OTORP__(Namval_t *np;const char* val;int flags;Namfun_t *handle;){
	struct vardisc *vp = (struct vardisc*)handle;
	Namval_t *nq, **disc;
	if(val)
	{
		if(!(nq=vp->disc[ASSIGN]))
		{
			nv_putv(np,val,flags,handle);
			return;
		}
		nv_putval(SH_VALNOD, val, (flags&NV_INTEGER)?NV_NOFREE|NV_INTEGER|NV_DOUBLE|NV_EXPNOTE:NV_NOFREE);
	}
	disc = (val? &(vp->disc[ASSIGN]):&(vp->disc[UNASSIGN]));
	if((nq= *disc) && nq!=BLOCKED)
	{
		*disc=BLOCKED;
		sh_fun(nq,np);
		if(*disc==BLOCKED)
			*disc=nq;
		else if(!*disc)
			chktfree(np,vp);
	}
	if(val)
	{
		char *cp;
		double d;
		if(nv_isnull(SH_VALNOD))
			cp=0;
		else if(flags&NV_INTEGER)
		{
			d = nv_getnum(SH_VALNOD);
			cp = (char*)(&d);
		}
		else
			cp = nv_getval(SH_VALNOD);
		if(cp)
			nv_putv(np,cp,flags|NV_RDONLY,handle);
		nv_unset(SH_VALNOD);
	}
	else if(!nq || nq==BLOCKED)
	{
		if(vp->disc[ASSIGN])
			nv_unset(vp->disc[ASSIGN]);
		if(vp->disc[LOOKUP])
			nv_unset(vp->disc[LOOKUP]);
		if(vp->disc[UNASSIGN])
			nv_unset(vp->disc[UNASSIGN]);
		if(handle=nv_stack(np, NIL(Namfun_t*)))
			free((__V_*)handle);
		nv_unset(np);
	}
}

/*
 * This function executes a lookup disc and then performs
 * the lookup on the given node <np>
 */
static char*	lookup __PARAM__((Namval_t *np, Namfun_t *handle), (np, handle)) __OTORP__(Namval_t *np; Namfun_t *handle;){
	struct vardisc *vp = (struct vardisc*)handle;
	Namval_t *nq;
	char *cp=0;
	if((nq=vp->disc[LOOKUP]) &&  nq!=BLOCKED)
	{
		nv_unset(SH_VALNOD);
		vp->disc[LOOKUP]=BLOCKED;
		sh_fun(nq,np);
		if(vp->disc[LOOKUP]==BLOCKED)
			vp->disc[LOOKUP]=nq;
		else if(!vp->disc[LOOKUP])
			chktfree(np,vp);
		cp = nv_getval(SH_VALNOD);
	}
	if(!cp)
		cp = nv_getv(np,handle);
	return(cp);
}

/*
 * node creation discipline
 */
Namval_t *nv_create __PARAM__((Namval_t* np,const char *name,Namfun_t *fp), (np, name, fp)) __OTORP__(Namval_t* np;const char *name;Namfun_t *fp;){
	if(np == (Namval_t*)fp)
		fp = np->nvfun;
	else if(fp)
		fp = fp->next;
	while(fp && !fp->disc->create)
		fp = fp->next;
	if(fp && fp->disc->create)
		return((*fp->disc->create)(np,name,fp));
	return(NIL(Namval_t*));
}

static const Namdisc_t shdisc =
{
	sizeof(struct vardisc),
	assign,
	lookup
};


/*
 * Set disc on given <event> to <action>
 * If action==np, the current disc is returned
 * A null return value indicates that no <event> is known for <np>
 * If <event> is NULL, then return the event name after <action>
 * If <event> is NULL, and <action> is NULL, return the first event
 */
char *nv_setdisc __PARAM__((Namval_t* np,const char *event,Namval_t *action,Namfun_t *fp), (np, event, action, fp)) __OTORP__(Namval_t* np;const char *event;Namval_t *action;Namfun_t *fp;){
	struct vardisc *vp = (struct vardisc*)np->nvfun;
	int type;
	if(np == (Namval_t*)fp)
	{
		static const char *discnames[] = { "get", "set", "unset", 0 };
		const char *name;
		int getname=0;
		/* top level call, check for get/set */
		if(!event)
		{
			if(!action)
				return((char*)discnames[0]);
			getname=1;
			event = (char*)action;
		}
		for(type=0; name=discnames[type]; type++)
		{
			if(strcmp(event,name)==0)
				break;
		}
		if(getname)
		{
			event = 0;
			if(name && !(name = discnames[++type]))
				action = 0;
		}
		if(!name)
		{
			if((fp=(Namfun_t*)vp) && fp->disc->setdisc)
				return((*fp->disc->setdisc)(np,event,action,fp));
		}
		else if(getname)
			return((char*)name);
	}
	if(!fp)
		return(NIL(char*));
	if(np != (Namval_t*)fp)
	{
		/* not the top level */
		while(fp = fp->next)
		{
			if(fp->disc->setdisc)
				return((*fp->disc->setdisc)(np,event,action,fp));
		}
		return(NIL(char*));
	}
	/* Handle GET/SET/UNSET disc */
	if(vp && vp->fun.disc->putval!=assign)
		vp = 0;
	if(!vp)
	{
		if(action==np)
			return((char*)action);
		if(!(vp = newof(NIL(struct vardisc*),struct vardisc,1,0)))
			return(0);
		vp->fun.disc = &shdisc;
		nv_stack(np, (Namfun_t*)vp);
	}
	if(action==np)
		action = vp->disc[type];
	else if(action)
		vp->disc[type] = action;
	else
	{
		action = vp->disc[type];
		vp->disc[type] = 0;
		if(action!=BLOCKED)
			chktfree(np,vp);
	}
	return(action?(char*)action:"");
}

/*
 * Create a reference node from <np>
 */
void nv_setref __PARAM__((Namval_t *np), (np)) __OTORP__(Namval_t *np;){
	Namval_t *nq, *nr;
	char *cp;
	int flags = NV_ARRAY|NV_VARNAME|NV_REF;
	Hashtab_t *hp=sh.var_tree;
	if(nv_isattr(np,NV_REF))
		return;
	if(nv_isattr(np,NV_ARRAY))
		error(ERROR_exit(1),e_badref,nv_name(np));
	if(!(cp=nv_getval(np)))
		error(ERROR_exit(1),e_noref,nv_name(np));
	if(np->nvsize&NV_PARAM)
	{
		if(!(hp=(Hashtab_t*)sh.st.par_tree))
		{
			if(!(hp=hashscope(sh.var_tree)))
				hp = sh.var_tree;
		}
	}
	nr= nq = nv_open(cp, hp, NV_ARRAY|NV_VARNAME|NV_REF);
	while(nv_isattr(nr,NV_REF))
		nr = nr->nvalue.np;
	if(nr==np) 
	{
		if(!(hp=hashscope(hp)))
			error(ERROR_exit(1),e_selfref,nv_name(np));
		/* bind to earlier scope, or add to global scope */
		nq=nv_search((char*)np,hp,NV_ADD|HASH_BUCKET);
	}
	nv_unset(np);
	np->nvalue.np = nq;
	nv_onattr(np,NV_REF|NV_NOFREE);
}

/*
* return the scope corresponding to <index>
* if <index>==0, global scope returned
* otherwise <index>th previous scope on function call stack returned
* If <index> greater than or equal to number of scopes, NULL returned
*/
Hashtab_t *nv_getscope(int index)
{
	Hashtab_t *hp;
	struct sh_scoped *sp;
	if(index==0)    /* return global scope */
		return((hp=hashscope(sh.var_tree))?hp:sh.var_tree);
	sp = &sh.st;
	while(sp && index-->0)
	{
		if(--index==0)
			return((Hashtab_t*)sp->par_tree);
		sp = sp->prevst;
	}
	return(NIL(Hashtab_t*));

}
