/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: fmtperm.c /main/3 1995/11/01 18:44:59 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*         THIS IS PROPRIETARY SOURCE CODE LICENSED BY          *
*                          AT&T CORP.                          *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*                     All Rights Reserved                      *
*                                                              *
*           This software is licensed by AT&T Corp.            *
*       under the terms and conditions of the license in       *
*       http://www.research.att.com/orgs/ssr/book/reuse        *
*                                                              *
*               This software was created by the               *
*           Software Engineering Research Department           *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                     gsf@research.att.com                     *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
#include <ast.h>
#include <ls.h>

char*
fmtperm __PARAM__((int perm), (perm)) __OTORP__(int perm;){
	char*	s;
	char*	p;
	char*		o;
	int		c;

	static char	buf[32];

	s = buf;

	/*
	 * ugo
	 */

	p = s;
	*s++ = c = '=';
	o = s;
	if (perm & S_ISVTX) *s++ = 't';
	if ((perm & (S_ISUID|S_ISGID)) == (S_ISUID|S_ISGID))
	{
		perm &= ~(S_ISUID|S_ISGID);
		*s++ = 's';
	}
	if ((perm & (S_IRUSR|S_IRGRP|S_IROTH)) == (S_IRUSR|S_IRGRP|S_IROTH))
	{
		perm &= ~(S_IRUSR|S_IRGRP|S_IROTH);
		*s++ = 'r';
	}
	if ((perm & (S_IWUSR|S_IWGRP|S_IWOTH)) == (S_IWUSR|S_IWGRP|S_IWOTH))
	{
		perm &= ~(S_IWUSR|S_IWGRP|S_IWOTH);
		*s++ = 'w';
	}
	if ((perm & (S_IXUSR|S_IXGRP|S_IXOTH)) == (S_IXUSR|S_IXGRP|S_IXOTH))
	{
		perm &= ~(S_IXUSR|S_IXGRP|S_IXOTH);
		*s++ = 'x';
	}
	if (s == o) s = p;
	else c = '+';

	/*
	 * ug
	 */

	p = s;
	if (s > buf) *s++ = ',';
	*s++ = 'u';
	*s++ = 'g';
	*s++ = c;
	o = s;
	if ((perm & (S_IRUSR|S_IRGRP)) == (S_IRUSR|S_IRGRP))
	{
		perm &= ~(S_IRUSR|S_IRGRP);
		*s++ = 'r';
	}
	if ((perm & (S_IWUSR|S_IWGRP)) == (S_IWUSR|S_IWGRP))
	{
		perm &= ~(S_IWUSR|S_IWGRP);
		*s++ = 'w';
	}
	if ((perm & (S_IXUSR|S_IXGRP)) == (S_IXUSR|S_IXGRP))
	{
		perm &= ~(S_IXUSR|S_IXGRP);
		*s++ = 'x';
	}
	if (s == o) s = p;
	else c = '+';

	/*
	 * u
	 */

	p = s;
	if (s > buf) *s++ = ',';
	*s++ = 'u';
	*s++ = c;
	o = s;
	if (perm & S_ISUID) *s++ = 's';
	if (perm & S_IRUSR) *s++ = 'r';
	if (perm & S_IWUSR) *s++ = 'w';
	if (perm & S_IXUSR) *s++ = 'x';
	if (s == o) s = p;
	else c = '+';

	/*
	 * go
	 */

	p = s;
	if (s > buf) *s++ = ',';
	*s++ = 'g';
	*s++ = 'o';
	*s++ = c;
	o = s;
	if ((perm & (S_IRGRP|S_IROTH)) == (S_IRGRP|S_IROTH))
	{
		perm &= ~(S_IRGRP|S_IROTH);
		*s++ = 'r';
	}
	if ((perm & (S_IWGRP|S_IWOTH)) == (S_IWGRP|S_IWOTH))
	{
		perm &= ~(S_IWGRP|S_IWOTH);
		*s++ = 'w';
	}
	if ((perm & (S_IXGRP|S_IXOTH)) == (S_IXGRP|S_IXOTH))
	{
		perm &= ~(S_IXGRP|S_IXOTH);
		*s++ = 'x';
	}
	if (s == o) s = p;
	else c = '+';

	/*
	 * g
	 */

	p = s;
	if (s > buf) *s++ = ',';
	*s++ = 'g';
	*s++ = c;
	o = s;
	if (perm & S_ISGID) *s++ = 's';
	if (perm & S_IRGRP) *s++ = 'r';
	if (perm & S_IWGRP) *s++ = 'w';
	if (perm & S_IXGRP) *s++ = 'x';
	if (s == o) s = p;
	else c = '+';

	/*
	 * o
	 */

	p = s;
	if (s > buf) *s++ = ',';
	*s++ = 'o';
	*s++ = '+';
	o = s;
	if (perm & S_IROTH) *s++ = 'r';
	if (perm & S_IWOTH) *s++ = 'w';
	if (perm & S_IXOTH) *s++ = 'x';
	if (s == o) s = p;
	if (s == buf) *s++ = '0';
	*s = 0;
	return(buf);
}
