/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: uname.c /main/3 1995/11/01 19:08:40 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*         THIS IS PROPRIETARY SOURCE CODE LICENSED BY          *
*                          AT&T CORP.                          *
*                                                              *
*                Copyright (c) 1995 AT&T Corp.                 *
*                     All Rights Reserved                      *
*                                                              *
*           This software is licensed by AT&T Corp.            *
*       under the terms and conditions of the license in       *
*       http://www.research.att.com/orgs/ssr/book/reuse        *
*                                                              *
*               This software was created by the               *
*           Software Engineering Research Department           *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                     gsf@research.att.com                     *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif
static const char id[] = "\n@(#)uname (AT&T Bell Laboratories) 05/09/95\0\n";

#if defined(__STDPP__directive) && defined(__STDPP__hide)
__STDPP__directive pragma pp:hide getdomainname gethostid gethostname sethostname
#else
#define getdomainname	______getdomainname
#define gethostid	______gethostid
#define gethostname	______gethostname
#define sethostname	______sethostname
#endif

#include <cmdlib.h>

#include "FEATURE/utsname"

#define MAXHOSTNAME	64

#if _lib_uname && _sys_utsname

#include <sys/utsname.h>

#endif

#if _sys_systeminfo
#if !_lib_systeminfo && _lib_syscall && _sys_syscall
#include <sys/syscall.h>
#if defined(SYS_systeminfo)
#define _lib_systeminfo		1
#define systeminfo(a,b,c)	syscall(SYS_systeminfo,a,b,c)
#endif
#endif
#if _lib_systeminfo
#if !defined(SYS_NMLEN)
#define SYS_NMLEN	9
#endif
#include <sys/systeminfo.h>
#endif
#endif

#if defined(__STDPP__directive) && defined(__STDPP__hide)
__STDPP__directive pragma pp:nohide getdomainname gethostid gethostname sethostname
#else
#undef	getdomainname
#undef	gethostid
#undef	gethostname
#undef	sethostname
#endif

#if _lib_getdomainname
extern __MANGLE__ int	getdomainname __PROTO__((char*, size_t));
#endif
#if _lib_gethostid
extern __MANGLE__ int	gethostid __PROTO__((void));
#endif
#if _lib_gethostname
extern __MANGLE__ int	gethostname __PROTO__((char*, size_t));
#endif
#if _lib_sethostname
extern __MANGLE__ int	sethostname __PROTO__((const char*, size_t));
#endif

#if !_lib_uname || !_sys_utsname

#if defined(__STDPP__)
#ifndef HOSTTYPE
#define HOSTTYPE	#(getprd hosttype)
#endif
#define SYSNAME		#(getprd machine)
#define RELEASE		#(getprd release)
#define VERSION		#(getprd version)
#define MACHINE		#(getprd architecture)
#else
#define SYSNAME		""
#define RELEASE		""
#define VERSION		""
#define MACHINE		""
#endif

struct utsname
{
	char*	sysname;
	char	nodename[MAXHOSTNAME];
	char*	release;
	char*	version;
	char*	machine;
};

int
uname __PARAM__((struct utsname* ut), (ut)) __OTORP__(struct utsname* ut;){
#ifdef HOSTTYPE
	char*		sys = 0;
	char*		arch = 0;
	static char	hosttype[] = HOSTTYPE;

	if (*hosttype)
	{
		sys = hosttype;
		if (arch = strchr(sys, '.'))
		{
			*arch++ = 0;
			if (!*arch) arch = 0;
		}
		if (!*sys) sys = 0;
	}
#endif
#ifdef _lib_gethostname
	if (gethostname(ut->nodename, sizeof(ut->nodename) - 1))
		return(-1);
#else
	strncpy(ut->nodename, "local", sizeof(ut->nodename) - 1);
#endif
#ifdef HOSTTYPE
	if (!(ut->sysname = sys))
#endif
	if (!*(ut->sysname = SYSNAME))
		ut->sysname = ut->nodename;
#ifdef HOSTTYPE
	if (!(ut->machine = arch))
#endif
	ut->machine = MACHINE;
	ut->release = RELEASE;
	ut->version = VERSION;
	return(0);
}

#endif

#define S_FLAG	(1<<0)
#define N_FLAG	(1<<1)
#define R_FLAG	(1<<2)
#define V_FLAG	(1<<3)
#define M_FLAG	(1<<4)

#define P_FLAG	(1<<5)
#define I_FLAG	(1<<6)
#define C_FLAG	(1<<7)
#define D_FLAG	(1<<8)
#define T_FLAG	(1<<9)
#define B_FLAG	(1<<10)

#define X_FLAG	(1<<11)

#define FLAGS	12

#define OPTBEG	"snrvm"
#define OPTEND	"aS:[nodename] "

#ifndef MACHINE
#if defined(__STDPP__)
#define MACHINE		#(getprd architecture)
#else
#define MACHINE		""
#endif
#endif

static int	all = ((M_FLAG<<1)-1);

#define extra(m)        do{if((char*)&ut.m[sizeof(ut.m)]>last)last=(char*)&ut.m[sizeof(ut.m)];}while(0)
#define output(f,v,u)	((flags&(f))?sfputr(sfstdout,*(v)?(v):(sfsprintf(buf,sizeof(buf),"[%s]",u),buf),flags>=((f)<<1)?' ':'\n'):0)

int
b_uname __PARAM__((int argc, char** argv), (argc, argv)) __OTORP__(int argc; char** argv;){
	int	n;
	int	flags = 0;
	char*	s;
	char*		sethost = 0;
	struct utsname	ut;
	char*		last = (char*)&ut.machine + sizeof(ut.machine);
	char		buf[257];

	static char	opts[sizeof(OPTBEG) + sizeof(OPTEND) + FLAGS] = OPTBEG;

	NoP(argc);
	NoP(id[0]);
	cmdinit(argv);
	s = &opts[sizeof(OPTBEG) - 1];
#if defined(__STDPP__) || defined(SI_ARCHITECTURE)
	*s++ = 'p';
	all |= P_FLAG;
#endif
#if _mem_idnumber_utsname || _lib_gethostid || defined(SI_HW_SERIAL)
	*s++ = 'i';
	all |= I_FLAG;
#if _mem_idnumber_utsname
	extra(idnumber);
#endif
#endif
#if defined(SI_HW_PROVIDER)
	*s++ = 'c';
	all |= C_FLAG;
#endif
#if _lib_getdomainname || defined(SI_SRPC_DOMAIN)
	*s++ = 'd';
	all |= D_FLAG;
#endif
#if _mem_m_type_utsname
	*s++ = 't';
	all |= T_FLAG;
	extra(m_type);
#endif
#if _mem_base_rel_utsname
	*s++ = 'b';
	all |= B_FLAG;
	extra(base_rel);
#endif
#if _lib_uname && _sys_utsname
	if (last < ((char*)(&ut + 1)))
	{
		*s++ = 'x';
		all |= X_FLAG;
	}
#endif
	strcpy(s, OPTEND);
	while (n = optget(argv, opts)) switch (n)
	{
	case 'a':
		flags = all;
		break;
#if _mem_base_rel_utsname
	case 'b':
		flags |= B_FLAG;
		break;
#endif
#if defined(SI_HW_PROVIDER)
	case 'c':
		flags |= C_FLAG;
		break;
#endif
#if _lib_getdomainname || defined(SI_SRPC_DOMAIN)
	case 'd':
		flags |= D_FLAG;
		break;
#endif
#if _mem_idnumber_utsname || _lib_gethostid || defined(SI_HW_SERIAL)
	case 'i':
		flags |= I_FLAG;
		break;
#endif
	case 'm':
		flags |= M_FLAG;
		break;
	case 'n':
		flags |= N_FLAG;
		break;
#if defined(__STDPP__) || defined(SI_ARCHITECTURE)
	case 'p':
		flags |= P_FLAG;
		break;
#endif
	case 'r':
		flags |= R_FLAG;
		break;
	case 's':
		flags |= S_FLAG;
		break;
#if _mem_m_type_utsname
	case 't':
		flags |= T_FLAG;
		break;
#endif
	case 'v':
		flags |= V_FLAG;
		break;
	case 'x':
		flags |= X_FLAG;
		break;
	case 'S':
		sethost = opt_info.arg;
		break;
	case ':':
		error(2, opt_info.arg);
		break;
	case '?':
		error(ERROR_usage(2), opt_info.arg);
		break;
	}
	argv += opt_info.index;
	if (error_info.errors || *argv || sethost && flags)
		error(ERROR_usage(2), optusage(NiL));
	if (sethost)
	{
#if _lib_sethostname
		if (sethostname(sethost, strlen(sethost) + 1))
#else
#ifdef	ENOSYS
		errno = ENOSYS;
#else
		errno = EPERM;
#endif
#endif
		error(ERROR_system(1), "%s: cannot set host name", sethost);
	}
	else
	{
		s = buf;
		if (!flags)
			flags = S_FLAG;
		memzero(&ut, sizeof(ut));
		if (uname(&ut) < 0)
			error(ERROR_usage(2), "information unavailable");
		output(S_FLAG, ut.sysname, "sysname");
#if !_mem_nodeext_utsname && _lib_gethostname
		if ((flags & N_FLAG) && sizeof(ut.nodename) <= 9 && !gethostname(s, sizeof(buf)))
			output(N_FLAG, s, "nodename");
		else
#endif
		output(N_FLAG, ut.nodename, "nodename");
		output(R_FLAG, ut.release, "release");
		output(V_FLAG, ut.version, "version");
		output(M_FLAG, ut.machine, "machine");
#if defined(__STDPP__) || defined(SI_ARCHITECTURE)
		if (flags & P_FLAG)
		{
#if defined(SI_ARCHITECTURE)
			if ((n = systeminfo(SI_ARCHITECTURE, s, sizeof(buf) - 1)) > 0) s[n] = 0;
			else *s = 0;
#else
			strncpy(s, MACHINE, sizeof(buf) - 1);
#endif
			output(P_FLAG, s, "processor");
		}
#endif
#if _mem_idnumber_utsname
		output(I_FLAG, ut.idnumber, "id");
#else
#if _lib_gethostid || defined(SI_HW_SERIAL)
		if (flags & I_FLAG)
		{
#if _lib_gethostid
			sfsprintf(s, sizeof(buf), "%08x", gethostid());
#else
			if ((n = systeminfo(SI_HW_SERIAL, s, sizeof(buf) - 1)) > 0) s[n] = 0;
			else *s = 0;
#endif
			output(I_FLAG, s, "id");
		}
#endif
#endif
#if defined(SI_HW_PROVIDER)
		if (flags & C_FLAG)
		{
			if ((n = systeminfo(SI_HW_PROVIDER, s, sizeof(buf) - 1)) > 0) s[n] = 0;
			else *s = 0;
			output(C_FLAG, s, "vendor");
		}
#endif
#if _lib_getdomainname || defined(SI_SRPC_DOMAIN)
		if (flags & D_FLAG)
		{
#if _lib_getdomainname
			if (getdomainname(s, sizeof(buf)) < 0)
				*s = 0;
#else
			if ((n = systeminfo(SI_SRPC_DOMAIN, s, sizeof(buf) - 1)) > 0) s[n] = 0;
			else *s = 0;
#endif
			output(D_FLAG, s, "domain");
		}
#endif
#if _mem_m_type_utsname
		output(T_FLAG, ut.m_type, "m_type");
#endif
#if _mem_base_rel_utsname
		output(B_FLAG, ut.base_rel, "base_rel");
#endif
		if (flags & X_FLAG)
		{
			char*	b;
			int	sep = 0;

			s = b = last;
			while (s < (char*)(&ut + 1))
			{
				if (!(n = *s++))
				{
					if ((s - b) > 1)
					{
						if (sep) sfputc(sfstdout, ' ');
						else sep = 1;
						sfputr(sfstdout, b, -1);
					}
					b = s;
				}
				else if (n < 0x20 || n >= 0x7E) break;
			}
			sfputc(sfstdout, '\n');
		}
	}
	return(error_info.errors);
}
